module Extract where

{- type-directed extraction of Haskell programs with a lot of unsafeCoerce

Examples:
---------

MiniAgda

  data Vec (A : Set) : Nat -> Set
  { vnil  : Vec A zero
  ; vcons : [n : Nat] -> A -> Vec A n -> Vec A (suc n) 
  }

  fun length : [A : Set] -> [n : Nat] -> Vec A n -> <n : Nat>
  { length .A .zero (vnil A) = zero
  ; length .A .(suc n) (vcons A n a as) = suc (length A n as)
  } 

Haskell

  data Vec a where
  { vnil  : Vec a
  ; vcons : a -> Vec a -> Vec a 
  }

  length : forall a. Vec a -> Nat
  length vnil = zero
  length (vcons a as) = suc (length as)

-}

import Text.PrettyPrint

